// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot.command;

import edu.wpi.first.wpilibj2.command.Command;
import frc.robot.subsystem.Accumulateur;
import frc.robot.subsystem.Balayeuse;

public class Balayer extends Command {
  private Balayeuse balayeuse;
  private Accumulateur accumulateur;
  /** Creates a new Balayer. */
  public Balayer(Balayeuse balayeuse, Accumulateur accumulateur) {
    this.balayeuse = balayeuse; 
    this.accumulateur = accumulateur;
    addRequirements(balayeuse, accumulateur);}
    // Use addRequirements() here to declare subsystem dependencies.
  // Called when the command is initially scheduled.
  @Override
  public void initialize() {}

  // Called every time the scheduler runs while the command is scheduled.
  @Override
  public void execute() {
    if(accumulateur.limitswitch()){
    balayeuse.balaye(0);
    accumulateur.Accumuler(0);
  }
  else{
    balayeuse.balaye(0.3);
    accumulateur.Accumuler();
  }
}

  // Called once the command ends or is interrupted.
  @Override
  public void end(boolean interrupted) {
    balayeuse.balaye(0);
    accumulateur.Accumuler(0);
  }

  // Returns true when the command should end.
  @Override
  public boolean isFinished() {
    return accumulateur.limitswitch()==true;
  }
}
