// Copyright (c) FIRST and other WPILib contributors.
// Open Source Software; you can modify and/or share it under the terms of
// the WPILib BSD license file in the root directory of this project.

package frc.robot.command;

import java.util.function.DoubleSupplier;

import edu.wpi.first.wpilibj2.command.Command;
import frc.robot.subsystem.Grimpeur;

public class GrimpeurGauche extends Command {
  private DoubleSupplier doubleSupplier;
  private Grimpeur grimpeur;
  /** Creates a new GrimpeurHautGauche. */
  public GrimpeurGauche(Grimpeur grimpeur,DoubleSupplier doubleSupplier) {
    this.doubleSupplier = doubleSupplier;
    this.grimpeur = grimpeur;
    addRequirements(grimpeur);
    // Use addRequirements() here to declare subsystem dependencies.
  }

  // Called when the command is initially scheduled.
  @Override
  public void initialize() {
    grimpeur.resetencodeurg();

  }

  // Called every time the scheduler runs while the command is scheduled.
  @Override
  public void execute() {
    grimpeur.gauche(doubleSupplier.getAsDouble());
   if(grimpeur.getpitch()<-15){
      grimpeur.gauche(doubleSupplier.getAsDouble());
    }
    else if(grimpeur.getpitch()>15){
      grimpeur.gauche(-doubleSupplier.getAsDouble());
    }
    else{
      grimpeur.gauche(0);
    }
    if(grimpeur.encoderg()<0){
      grimpeur.gauche(doubleSupplier.getAsDouble());
    }
  else{
    grimpeur.gauche(0);
  }
  }

  // Called once the command ends or is interrupted.
  @Override
  public void end(boolean interrupted) {
    grimpeur.gauche(0);
  }

  // Returns true when the command should end.
  @Override
  public boolean isFinished() {
    return false;
  }
}
